extern char *malloc(), *realloc();

# include	"common.h"
# include	"ast.h"
# include	"scanner.h"
# include       "micro.h"

# define	Not_Implemented \
		mcprintf("Unimplemented feature\n",0,0)
extern	char	yytext[];
extern	FILE *	yyin;
extern	int	line_num;

#define YYSTYPE AST_Ptr
# define T_Id 257
# define T_Integer 258
# define T_String 259
# define T_Real 260
# define T_Boolean 261
# define CLEAR 262
# define T_Source 263
# define T_Gets 264
# define T_Where 265
# define T_St 266
# define T_Iff 267
# define T_Impl 268
# define T_Or 269
# define T_And 270
# define T_Not 271
# define T_In 272
# define T_Notin 273
# define T_Subset 274
# define T_Lt 275
# define T_Le 276
# define T_Eq 277
# define T_Ne 278
# define T_Gt 279
# define T_Ge 280
# define INFIX 281
# define T_Plus 282
# define T_Minus 283
# define T_With 284
# define T_Less 285
# define T_Times 286
# define T_Slash 287
# define T_Mod 288
# define T_Div 289
# define T_Exp 290
# define T_Insert 291
# define UNARY 292
# define CALL 293
# define T_Dotdot 294
# define T_Missing 295
# define T_Arrow 296
# define T_Take 297
# define T_To 298
# define T_Choose 299
# define T_Do 300
# define T_Else 301
# define T_Elseif 302
# define T_End 303
# define T_Exists 304
# define T_False 305
# define T_For 306
# define T_Forall 307
# define T_From 308
# define T_Fromb 309
# define T_Frome 310
# define T_Func 311
# define T_If 312
# define T_Local 313
# define T_Newat 314
# define T_Of 315
# define T_Om 316
# define T_Opt 317
# define T_Print 318
# define T_PrintF 319
# define T_Prog 320
# define T_Read 321
# define T_ReadF 322
# define T_Return 323
# define T_Then 324
# define T_True 325
# define T_Value 326
# define T_While 327
# define T_Write 328
# define T_Writeln 329
# define MAP 330
# define SELECTOR 331
# define ITERS 332
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256



void yyerror(i) char *i; {
    /*
    printf("%s, line %d. '!clear'\n", i, line_num);
    */
}

/* Return an new copy of string p */
    char * str(p) char * p; {
	char * new = malloc(strlen(p) + 1);
	if( new == NULL ) {
	    FATAL("Out of parsing space.");
	}
	strcpy(new,p);
	return new;
    }

int yyexca[] ={
-1, 0,
	257, 16,
	258, 16,
	259, 16,
	260, 16,
	266, 16,
	271, 16,
	282, 16,
	283, 16,
	291, 16,
	40, 16,
	123, 16,
	295, 16,
	297, 16,
	304, 16,
	305, 16,
	306, 16,
	307, 16,
	311, 16,
	312, 16,
	314, 16,
	316, 16,
	318, 16,
	319, 16,
	321, 16,
	322, 16,
	323, 16,
	325, 16,
	327, 16,
	328, 16,
	329, 16,
	91, 16,
	35, 16,
	-2, 0,
-1, 1,
	0, -1,
	-2, 0,
-1, 148,
	257, 16,
	258, 16,
	259, 16,
	260, 16,
	266, 16,
	271, 16,
	282, 16,
	283, 16,
	291, 16,
	40, 16,
	123, 16,
	295, 16,
	297, 16,
	304, 16,
	305, 16,
	306, 16,
	307, 16,
	311, 16,
	312, 16,
	314, 16,
	316, 16,
	318, 16,
	319, 16,
	321, 16,
	322, 16,
	323, 16,
	325, 16,
	327, 16,
	328, 16,
	329, 16,
	91, 16,
	35, 16,
	-2, 0,
-1, 163,
	63, 0,
	-2, 83,
-1, 164,
	64, 0,
	-2, 84,
-1, 174,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 94,
-1, 175,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 95,
-1, 176,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 96,
-1, 177,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 97,
-1, 178,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 98,
-1, 179,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 99,
-1, 180,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 100,
-1, 181,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 101,
-1, 182,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 102,
-1, 186,
	267, 0,
	-2, 106,
-1, 202,
	291, 0,
	-2, 108,
-1, 246,
	291, 0,
	-2, 107,
-1, 277,
	301, 13,
	302, 13,
	303, 13,
	-2, 16,
	};
# define YYNPROD 182
# define YYLAST 2064
int yyact[]={

    58,   315,   144,     4,   309,   230,    10,    20,   326,   301,
   314,   221,   153,    54,    56,   145,    56,   322,   151,   318,
   317,   136,   299,   297,   286,   275,   248,   214,   281,   151,
   153,   153,   210,   153,   209,   228,    95,    97,    97,   101,
   151,   127,   128,   129,   215,   213,   206,   140,   141,   142,
    38,   291,   250,    52,   204,    35,    10,   139,   188,   138,
   162,   227,   132,     1,   159,   160,   230,     5,   163,   164,
   165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
   175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
   185,   186,    94,   143,    56,   194,   229,   151,   223,     3,
    94,   130,   137,   202,    65,   201,    36,    94,   320,   198,
   102,   307,   279,   308,   280,    67,    68,   278,   209,   207,
    94,   277,   249,    53,    68,     7,    66,   205,   253,   231,
    96,   151,   189,   247,   147,   306,   146,    49,    37,   274,
    99,    34,    33,    67,    68,   131,    94,   149,    94,   298,
    98,   235,   236,   237,   238,   239,   240,   241,   242,   243,
   296,   234,   244,   245,    55,   300,    59,   265,   100,    67,
    68,    67,    68,   126,   133,    93,    57,    24,   252,   125,
   224,   226,   321,    93,   316,    22,    21,    10,   246,    19,
    93,    11,     6,    60,    61,    62,   255,   276,   222,   211,
    94,   257,   187,    93,   233,   258,    66,   260,   285,   262,
   148,   264,   232,     8,   266,     2,   268,     0,   270,   271,
   272,     0,     0,    67,    68,   134,   267,     0,   269,    93,
    94,    93,   273,     0,     0,    38,    66,     0,     0,     0,
    35,   196,     0,     0,   192,   193,     0,     3,     0,     0,
     0,   290,     0,    67,    68,   293,     0,     0,     0,   256,
     0,     0,   208,     0,     0,   261,   283,   190,     0,     0,
     0,    10,    10,    26,    28,    27,   152,    10,     0,   200,
     0,    50,   150,    93,   158,   157,    40,   156,   310,   311,
     0,    36,   312,   284,   155,    38,   251,    41,    42,     0,
    35,   292,     0,     0,     0,     0,    39,   319,   289,     0,
    25,   212,    47,    93,     0,   304,     0,     0,   323,    43,
    30,    45,    44,    37,     0,   282,    51,    48,     0,    32,
   324,    31,     0,    15,    16,     0,    13,    14,    12,   328,
    29,     0,    46,    17,    18,    92,     0,    90,    89,    88,
    87,    36,    84,    85,    86,    80,    82,    78,    79,    81,
    83,     0,    74,    75,    76,    77,    70,    71,    72,    73,
    69,    91,   303,     0,   305,    38,   302,     0,     0,     0,
    35,     0,     0,    37,   263,     0,     0,     0,     0,     0,
    10,     0,    70,    71,    72,    73,    69,    91,    69,    91,
     0,   123,   122,   121,   327,   118,   119,   120,   114,   116,
   112,   113,   115,   117,     0,   108,   109,   110,   111,   104,
   105,   106,   107,   103,   190,    92,     0,    90,    89,    88,
    87,    36,    84,    85,    86,    80,    82,    78,    79,    81,
    83,     0,    74,    75,    76,    77,    70,    71,    72,    73,
    69,    91,     0,     0,     0,     0,     0,    10,    26,    28,
    27,     0,     0,    37,     0,    38,    50,     0,     0,     0,
    35,    40,    74,    75,    76,    77,    70,    71,    72,    73,
    69,    91,    41,    42,   220,     0,     0,     0,     0,     0,
     0,    39,     0,     0,   195,    25,     0,     0,     0,     0,
     0,     0,     0,     0,    43,    30,     0,    44,     0,     0,
     0,    51,    48,     0,    32,     0,    31,    10,    26,    28,
    27,    36,     0,     0,    94,    29,    50,     0,     0,     0,
    66,    40,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    41,    42,     0,     0,     0,    67,    68,     0,
     0,    39,     0,    37,     0,    25,     0,     0,     0,     0,
     0,     0,     0,     0,    43,    30,     0,    44,     0,     0,
     0,    51,    48,     0,    32,     0,    31,     0,    94,     0,
     0,     0,     0,     0,    66,    29,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    10,    26,    28,
    27,    67,    68,     0,     0,     0,    50,    93,     0,     0,
     0,    40,     0,     0,     0,     0,     0,     0,     0,    94,
     0,     0,    41,    42,     0,    66,     0,     0,     0,     0,
     0,    39,     0,     0,     0,    25,     0,     0,    63,     0,
     0,     0,    67,    68,    43,    30,     0,    44,     0,    94,
     0,    51,    48,     0,    32,    66,    31,     0,     0,     0,
    94,    93,     0,     0,     0,    29,     0,     0,     0,     0,
     0,     0,    67,    68,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    67,    68,     0,     0,    10,    26,    28,
    27,     0,     0,    94,   313,     0,    50,     0,     0,    66,
     0,    40,    93,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    41,    42,     0,     0,    67,    68,     0,     0,
     0,    39,     0,     0,     0,    25,     0,     0,     0,     0,
     0,     0,    93,     0,    43,    30,     0,    44,     0,     0,
     0,    51,    48,    93,    32,     0,    31,     0,     0,    92,
     0,    90,    89,    88,    87,    29,    84,    85,    86,    80,
    82,    78,    79,    81,    83,     0,    74,    75,    76,    77,
    70,    71,    72,    73,    69,    91,    93,    94,   295,     0,
     0,     0,     0,    66,     0,     0,     0,     0,     0,     0,
     0,     0,   219,   218,   217,     0,     0,     0,     0,     0,
    67,    68,     0,    92,     0,    90,    89,    88,    87,     0,
    84,    85,    86,    80,    82,    78,    79,    81,    83,     0,
    74,    75,    76,    77,    70,    71,    72,    73,    69,    91,
     0,     0,     0,     0,     0,     0,     0,     0,   216,     0,
     0,     0,     0,     0,    92,     0,    90,    89,    88,    87,
     0,    84,    85,    86,    80,    82,    78,    79,    81,    83,
    93,    74,    75,    76,    77,    70,    71,    72,    73,    69,
    91,     0,     0,   254,    92,   325,    90,    89,    88,    87,
     0,    84,    85,    86,    80,    82,    78,    79,    81,    83,
     0,    74,    75,    76,    77,    70,    71,    72,    73,    69,
    91,     0,    74,    75,    76,    77,    70,    71,    72,    73,
    69,    91,     0,     0,     0,     0,     0,     0,    92,     0,
    90,    89,    88,    87,     0,    84,    85,    86,    80,    82,
    78,    79,    81,    83,     0,    74,    75,    76,    77,    70,
    71,    72,    73,    69,    91,     0,    94,   294,     0,     0,
     0,     0,    66,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    67,
    68,     0,     0,    94,   288,     0,     0,     0,     0,    66,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    67,    68,     0,     0,
     0,     0,    92,     0,    90,    89,    88,    87,     0,    84,
    85,    86,    80,    82,    78,    79,    81,    83,     0,    74,
    75,    76,    77,    70,    71,    72,    73,    69,    91,    93,
    94,     0,     0,     0,     0,     0,    66,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    67,    68,     0,    93,    94,   259,     0,
     0,     0,     0,    66,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    67,    68,     0,     0,    94,     0,     0,     0,     0,     0,
    66,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    67,    68,     0,
     0,     0,     0,    93,     0,     0,     0,     0,     0,     0,
     0,    94,   197,     0,     0,     0,     0,    66,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    93,     0,     0,     0,    67,    68,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    93,     0,     0,
     0,    92,     0,    90,    89,    88,    87,     0,    84,    85,
    86,    80,    82,    78,    79,    81,    83,     0,    74,    75,
    76,    77,    70,    71,    72,    73,    69,    91,    92,     0,
    90,    89,    88,    87,    93,    84,    85,    86,    80,    82,
    78,    79,    81,    83,     0,    74,    75,    76,    77,    70,
    71,    72,    73,    69,    91,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    92,   287,    90,    89,    88,
    87,     0,    84,    85,    86,    80,    82,    78,    79,    81,
    83,     0,    74,    75,    76,    77,    70,    71,    72,    73,
    69,    91,    92,     0,    90,    89,    88,    87,     0,    84,
    85,    86,    80,    82,    78,    79,    81,    83,     0,    74,
    75,    76,    77,    70,    71,    72,    73,    69,    91,    92,
   199,    90,    89,    88,    87,     0,    84,    85,    86,    80,
    82,    78,    79,    81,    83,     0,    74,    75,    76,    77,
    70,    71,    72,    73,    69,    91,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    92,     0,    90,    89,
    88,    87,     0,    84,    85,    86,    80,    82,    78,    79,
    81,    83,     0,    74,    75,    76,    77,    70,    71,    72,
    73,    69,    91,    94,     0,     0,     0,     0,     0,    66,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    67,    68,     0,     0,
     0,    94,     0,     0,     0,     0,     0,    66,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    67,    68,     0,     0,    94,     0,
     0,     0,     0,     0,    66,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    67,    68,    94,     0,     0,    93,     0,     0,    66,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    67,    68,     0,    94,
     0,     0,     0,     0,    93,    66,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    67,    68,    94,     0,     0,     0,     0,     0,
    66,    93,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    67,    68,     0,
     0,    94,     0,     0,     0,     0,    93,    66,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    67,    68,     0,     0,     0,    94,
     0,     0,    93,     0,     0,    66,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    67,    68,     0,     0,     0,    93,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    92,   154,
    90,    89,    88,    87,     0,    84,    85,    86,    80,    82,
    78,    79,    81,    83,    93,    74,    75,    76,    77,    70,
    71,    72,    73,    69,    91,    64,    92,     0,    90,    89,
    88,    87,     0,    84,    85,    86,    80,    82,    78,    79,
    81,    83,    93,    74,    75,    76,    77,    70,    71,    72,
    73,    69,    91,    92,     0,    90,    89,    88,    87,     0,
    84,    85,    86,    80,    82,    78,    79,    81,    83,     0,
    74,    75,    76,    77,    70,    71,    72,    73,    69,    91,
    90,    89,    88,    87,     0,    84,    85,    86,    80,    82,
    78,    79,    81,    83,     0,    74,    75,    76,    77,    70,
    71,    72,    73,    69,    91,     0,     0,    89,    88,    87,
     0,    84,    85,    86,    80,    82,    78,    79,    81,    83,
     0,    74,    75,    76,    77,    70,    71,    72,    73,    69,
    91,     0,     0,    88,    87,     0,    84,    85,    86,    80,
    82,    78,    79,    81,    83,     0,    74,    75,    76,    77,
    70,    71,    72,    73,    69,    91,     0,     0,     0,     0,
     0,    87,     0,    84,    85,    86,    80,    82,    78,    79,
    81,    83,     0,    74,    75,    76,    77,    70,    71,    72,
    73,    69,    91,    23,     0,     0,     0,     0,     0,     9,
     0,    84,    85,    86,    80,    82,    78,    79,    81,    83,
     0,    74,    75,    76,    77,    70,    71,    72,    73,    69,
    91,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   124,     0,     0,     0,   135,   135,   135,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   161,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   124,   191,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   203,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   135,     0,     0,     0,     0,     0,     0,     0,   225,   225,
   225,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   135,     0,     0,     0,     0,     0,     0,
     0,   135,     0,   135,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   225,   225,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   191,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   225 };
int yypact[]={

  -253, -1000, -1000,    66, -1000,  -201,    15, -1000,  -209,    64,
 -1000, -1000,   430,   430,   430,   430,   430,   430,   340, -1000,
  1361, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000,   430,   430,   430,   430,   133,
   430,   430,   430,   -70,   -70,   -70,   430,   430,   430,  -311,
 -1000, -1000, -1000,  -311,  1388,   -26,  1388,   -32,  1333,    -4,
   -11,   -13,   -14,   430,   430, -1000,    20,   430,   430,   430,
   430,   430,   430,   430,   430,   430,   430,   430,   430,   430,
   430,   430,   430,   430,   430,   430,   430,   430,   430,   430,
   430,   133,   -70,   430,   200,  1081,    16,  1044,   -15, -1000,
   -20,    67,   430, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000,    14,   430,  1519,    67,    67,
  -220,    75,   -10,  -245, -1000, -1000,   -70,  -221,  -273,  -222,
   538,   484,   160, -1000,  -201,  -201,  -251,    89,  -253, -1000,
   430,   430,   430,   430,   430,   430,   430,   430,   430,  1388,
  1388,   430,   430,    60,    67,   108,   108,   108,   108,   108,
   106,   106,   106,   106,   190,   190,   190,   190,   190,   190,
   190,   190,   190,  1519,  1491,  1464,  1439,   430,  -277,    63,
  -212,    67,    53,    87,   579,   430, -1000, -1000, -1000,   -70,
   430, -1000,    52, -1000,   430,  1017,   430,   -70,   430,   -70,
   430,    74, -1000,   430, -1000,   430, -1000,   430,   430,   430,
 -1000,  -278,    62, -1000,    58,    68,    55,  -268,  -312, -1000,
  -201,  -251, -1000,  -279, -1000,  1388,  1388,  1388,   990,  1388,
  1388,  1388,  1388,  1388,   620,   933,    52, -1000, -1000,   -70,
   430,  -213, -1000, -1000,   260,   906, -1000,  1388,   737, -1000,
  1413, -1000,  1388, -1000,  1388, -1000,  1413,  -280,  1388,  -281,
  1388,  1388,  1388, -1000, -1000,  -302, -1000, -1000,  -311,  -201,
  -311, -1000, -1000, -1000,    70,    54,  -316,   430,   430, -1000,
  1388,   430, -1000,   653, -1000, -1000, -1000,  -296, -1000,  -326,
  -282, -1000, -1000, -1000, -1000, -1000,   430,    49, -1000, -1000,
  1388,   620,  1388, -1000, -1000, -1000,  -286,   430, -1000,   609,
 -1000, -1000,  -304,    80, -1000, -1000, -1000, -1000, -1000 };
int yypgo[]={

     0,    63,  1783,   215,    98,   213,   210,   208,    93,   204,
    11,   198,   197,   192,   191,     0,   150,   176,   189,   186,
   185,   184,   182,   177,   165,   160,   149,    59,    57,   145,
    62,   174,   104,   142,   141,   130,   110,   140,   139,   137,
   136,    61,   135,    35,    96,   134,   133,    58,   132 };
int yyr1[]={

     0,     2,     1,     1,     5,     6,     1,     7,     7,     3,
     9,    10,    12,    12,    11,    11,    13,     4,    14,    14,
    14,    14,    14,    14,    14,    14,    14,    14,    14,    14,
    14,    14,    14,    14,    14,    14,    14,    14,    21,    21,
    22,    22,    23,    24,    24,    25,    25,    26,    26,    19,
    19,    27,    27,    28,    28,    29,    29,    32,    32,    32,
    32,    32,    32,    18,    15,    15,    15,    15,    15,    15,
    15,    15,    15,    15,    15,    15,    15,    15,    15,    15,
    15,    15,    15,    15,    15,    15,    15,    15,    15,    15,
    15,    15,    15,    15,    15,    15,    15,    15,    15,    15,
    15,    15,    15,    15,    15,    15,    15,    15,    15,    15,
    15,    15,    15,    15,    16,    16,    17,    17,    17,    17,
    37,    20,    20,    20,    35,    35,    35,    35,    36,    36,
    36,    36,    36,    36,    36,    36,    36,    36,    36,    36,
    36,    36,    36,    36,    36,    36,    36,    36,    36,    36,
    36,    36,    36,    38,    38,    33,    40,    42,    33,    41,
    41,    45,    39,    44,    44,     8,     8,     8,    43,    43,
    46,    34,    47,    47,    47,    48,    48,    31,    31,    31,
    30,    30 };
int yyr2[]={

     0,     3,     3,     5,     1,     1,    11,     2,     4,    15,
     2,     5,     0,     2,     7,     3,     1,     5,     3,     5,
     5,     9,     5,     9,     5,     9,     5,     9,     5,     9,
     5,     9,     3,     7,     2,     3,     2,     2,     5,     1,
     2,     4,    15,    11,     1,     2,     4,     2,     4,    11,
    11,     3,     7,     7,     3,     7,     7,     7,     7,     9,
     9,    11,     5,     7,     2,     2,     3,     3,     3,     3,
     3,     3,     3,     3,     2,     2,     7,     7,     7,     5,
     5,     9,    13,     7,     7,     7,     7,     7,     7,     7,
     7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
     7,     7,     7,     7,     7,     7,     7,     9,     7,     5,
     5,     5,     9,     9,     3,     7,     3,     7,     7,    11,
     7,     9,     9,     9,     1,     7,     2,     2,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
     5,     7,     9,     2,     4,     9,     1,     1,    15,     5,
     3,     1,    13,     1,     5,     1,     9,     9,     3,     7,
     2,     9,     3,     5,     7,     7,     9,     3,     2,     7,
     3,     7 };
int yychk[]={

 -1000,    -1,    -3,    -4,   256,   320,   -13,    59,    -5,    -2,
   257,   -14,   323,   321,   322,   318,   319,   328,   329,   -18,
   -15,   -19,   -20,    -2,   -23,   295,   258,   260,   259,   325,
   305,   316,   314,   -33,   -34,    40,    91,   123,    35,   291,
   271,   282,   283,   304,   307,   306,   327,   297,   312,   -39,
   266,   311,   262,    59,   -15,   -16,   -15,   -17,   -15,   -16,
   -17,   -17,   -17,   298,   264,   -32,    46,    63,    64,   290,
   286,   287,   288,   289,   282,   283,   284,   285,   277,   278,
   275,   279,   276,   280,   272,   273,   274,   270,   269,   268,
   267,   291,   265,   123,    40,   -15,   -35,   -15,   -16,   -37,
   -35,   -15,   -36,   290,   286,   287,   288,   289,   282,   283,
   284,   285,   277,   278,   275,   279,   276,   280,   272,   273,
   274,   270,   269,   268,    -2,    46,    40,   -15,   -15,   -15,
   -28,   -29,   -30,   -31,   295,    -2,    91,   -28,   -27,   -28,
   -15,   -15,   -15,    -8,   313,   326,   -40,   -45,    -6,    -8,
   308,    44,   308,    44,   266,   298,   298,   298,   298,   -15,
   -15,    -2,    40,   -15,   -15,   -15,   -15,   -15,   -15,   -15,
   -15,   -15,   -15,   -15,   -15,   -15,   -15,   -15,   -15,   -15,
   -15,   -15,   -15,   -15,   -15,   -15,   -15,   -36,   -47,   -48,
   -31,    -2,   -16,   -16,   -15,   294,    41,    41,    93,   266,
   294,   125,   -15,    -2,    40,   -15,   266,    44,   272,    44,
   277,   -30,   -31,   266,   300,   266,   300,   310,   309,   308,
   324,   -10,   -11,    -4,   -43,    -2,   -43,   -41,   -43,   -44,
   317,    40,    -1,    -9,   -10,   -15,   -15,   -15,   -15,   -15,
   -15,   -15,   -15,   -15,   -15,   -15,   -15,   -46,   303,    59,
   264,   -32,   125,    41,   294,   -15,   -27,   -15,   -15,    41,
   -15,   -28,   -15,   -31,   -15,    93,   -15,   -10,   -15,   -10,
   -15,   -15,   -15,   -10,   -38,   303,   -12,    59,    59,    44,
    59,   296,   -44,   -43,   -41,    -7,   303,   266,    41,   -47,
   -15,   264,    41,   -15,    41,    41,   -25,   303,   -26,   303,
   -24,   311,    -4,    -8,   -43,    -8,   -42,    41,    59,   320,
   -15,   -15,   -15,    41,   306,   327,   -21,   302,   301,   -15,
    59,   -22,   303,   -15,   -10,   266,   312,   324,   -10 };
int yydef[]={

    -2,    -2,     2,     0,     4,     0,     0,     3,     0,     0,
     1,    17,    18,     0,     0,     0,     0,     0,    32,    34,
    35,    36,    37,    64,    65,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,     0,   124,   124,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   165,
   156,   161,     5,   165,    19,    20,   114,    22,   116,    24,
    26,    28,    30,     0,     0,    80,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   114,   126,   127,
     0,    79,     0,   128,   129,   130,   131,   132,   133,   134,
   135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
   145,   146,   147,   148,   149,     0,     0,   109,   110,   111,
     0,    54,     0,   180,   177,   178,     0,     0,     0,    51,
     0,     0,     0,    16,     0,     0,   163,     0,    -2,    16,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    33,
    63,     0,     0,    -2,    -2,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    -2,    -2,    -2,    -2,    -2,    -2,
    -2,    -2,    -2,   103,   104,   105,    -2,     0,     0,   172,
     0,   178,     0,     0,   114,     0,    62,    76,    77,     0,
     0,    78,    -2,   150,     0,     0,     0,     0,     0,     0,
     0,     0,   180,     0,    16,     0,    16,     0,     0,     0,
    16,     0,    12,    15,     0,   168,     0,     0,   163,   160,
     0,   163,     6,     0,    10,    21,   115,    23,   118,   117,
    25,    27,    29,    31,    81,     0,    -2,   171,   170,   173,
     0,     0,    57,    58,     0,     0,   125,   120,     0,   151,
   112,    53,    55,   181,    56,   179,   113,     0,    52,     0,
   121,   122,   123,    44,   155,   153,    11,    -2,   165,     0,
   165,   157,   159,   164,     0,     0,     7,     0,     0,   174,
   175,     0,    59,     0,    60,   152,    49,    45,    50,    47,
    39,   154,    14,   166,   169,   167,     0,     0,     9,     8,
   119,    82,   176,    61,    46,    48,     0,     0,    16,     0,
   162,    42,    40,     0,    38,   158,    41,    16,    43 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"T_Id",	257,
	"T_Integer",	258,
	"T_String",	259,
	"T_Real",	260,
	"T_Boolean",	261,
	"CLEAR",	262,
	"T_Source",	263,
	"T_Gets",	264,
	"T_Where",	265,
	"T_St",	266,
	"T_Iff",	267,
	"T_Impl",	268,
	"T_Or",	269,
	"T_And",	270,
	"T_Not",	271,
	"T_In",	272,
	"T_Notin",	273,
	"T_Subset",	274,
	"T_Lt",	275,
	"T_Le",	276,
	"T_Eq",	277,
	"T_Ne",	278,
	"T_Gt",	279,
	"T_Ge",	280,
	"INFIX",	281,
	".",	46,
	"T_Plus",	282,
	"T_Minus",	283,
	"T_With",	284,
	"T_Less",	285,
	"T_Times",	286,
	"T_Slash",	287,
	"T_Mod",	288,
	"T_Div",	289,
	"T_Exp",	290,
	"T_Insert",	291,
	"?",	63,
	"@",	64,
	"UNARY",	292,
	"CALL",	293,
	"(",	40,
	"{",	123,
	"T_Dotdot",	294,
	"T_Missing",	295,
	"T_Arrow",	296,
	"T_Take",	297,
	"T_To",	298,
	"T_Choose",	299,
	"T_Do",	300,
	"T_Else",	301,
	"T_Elseif",	302,
	"T_End",	303,
	"T_Exists",	304,
	"T_False",	305,
	"T_For",	306,
	"T_Forall",	307,
	"T_From",	308,
	"T_Fromb",	309,
	"T_Frome",	310,
	"T_Func",	311,
	"T_If",	312,
	"T_Local",	313,
	"T_Newat",	314,
	"T_Of",	315,
	"T_Om",	316,
	"T_Opt",	317,
	"T_Print",	318,
	"T_PrintF",	319,
	"T_Prog",	320,
	"T_Read",	321,
	"T_ReadF",	322,
	"T_Return",	323,
	"T_Then",	324,
	"T_True",	325,
	"T_Value",	326,
	"T_While",	327,
	"T_Write",	328,
	"T_Writeln",	329,
	"MAP",	330,
	"SELECTOR",	331,
	"ITERS",	332,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"id : T_Id",
	"program : simple.program",
	"program : stmt ';'",
	"program : error",
	"program : error CLEAR",
	"program : error CLEAR program",
	"end.prog : T_End",
	"end.prog : T_End T_Prog",
	"simple.program : T_Prog id ';' dcls body end.prog ';'",
	"body : stmts",
	"stmts : stmt.list opt.semi",
	"opt.semi : /* empty */",
	"opt.semi : ';'",
	"stmt.list : stmt.list ';' stmt",
	"stmt.list : stmt",
	"stmt : /* empty */",
	"stmt : real.stmt",
	"real.stmt : T_Return",
	"real.stmt : T_Return expr",
	"real.stmt : T_Read expr.list",
	"real.stmt : T_Read expr.list T_From expr",
	"real.stmt : T_ReadF pair.list",
	"real.stmt : T_ReadF pair.list T_From expr",
	"real.stmt : T_Print expr.list",
	"real.stmt : T_Print expr.list T_To expr",
	"real.stmt : T_PrintF pair.list",
	"real.stmt : T_PrintF pair.list T_To expr",
	"real.stmt : T_Write pair.list",
	"real.stmt : T_Write pair.list T_To expr",
	"real.stmt : T_Writeln pair.list",
	"real.stmt : T_Writeln pair.list T_To expr",
	"real.stmt : T_Writeln",
	"real.stmt : T_Writeln T_To expr",
	"real.stmt : assignment",
	"real.stmt : expr",
	"real.stmt : loop.stmt",
	"real.stmt : from.stmt",
	"else.part : T_Else stmts",
	"else.part : /* empty */",
	"end.if : T_End",
	"end.if : T_End T_If",
	"if.stmt : T_If expr T_Then stmts else.ifs else.part end.if",
	"else.ifs : else.ifs T_Elseif expr T_Then stmts",
	"else.ifs : /* empty */",
	"end.for : T_End",
	"end.for : T_End T_For",
	"end.while : T_End",
	"end.while : T_End T_While",
	"loop.stmt : T_For iterator T_Do stmts end.for",
	"loop.stmt : T_While expr T_Do stmts end.while",
	"iterator : iter.list",
	"iterator : iter.list T_St expr",
	"iter.list : simple.iterator ',' iter.list",
	"iter.list : simple.iterator",
	"simple.iterator : bound.list T_In expr",
	"simple.iterator : bound T_Eq expr",
	"selector : '{' expr.list '}'",
	"selector : '(' expr.list ')'",
	"selector : '(' expr T_Dotdot ')'",
	"selector : '(' T_Dotdot expr ')'",
	"selector : '(' expr T_Dotdot expr ')'",
	"selector : '(' ')'",
	"assignment : expr T_Gets expr",
	"expr : id",
	"expr : if.stmt",
	"expr : T_Missing",
	"expr : T_Integer",
	"expr : T_Real",
	"expr : T_String",
	"expr : T_True",
	"expr : T_False",
	"expr : T_Om",
	"expr : T_Newat",
	"expr : func.const",
	"expr : where.clause",
	"expr : '(' expr ')'",
	"expr : '[' former ']'",
	"expr : '{' former '}'",
	"expr : '#' expr",
	"expr : expr selector",
	"expr : expr '.' id expr",
	"expr : expr '.' '(' expr ')' expr",
	"expr : expr '?' expr",
	"expr : expr '@' expr",
	"expr : expr T_Exp expr",
	"expr : expr T_Times expr",
	"expr : expr T_Slash expr",
	"expr : expr T_Mod expr",
	"expr : expr T_Div expr",
	"expr : expr T_Plus expr",
	"expr : expr T_Minus expr",
	"expr : expr T_With expr",
	"expr : expr T_Less expr",
	"expr : expr T_Eq expr",
	"expr : expr T_Ne expr",
	"expr : expr T_Lt expr",
	"expr : expr T_Gt expr",
	"expr : expr T_Le expr",
	"expr : expr T_Ge expr",
	"expr : expr T_In expr",
	"expr : expr T_Notin expr",
	"expr : expr T_Subset expr",
	"expr : expr T_And expr",
	"expr : expr T_Or expr",
	"expr : expr T_Impl expr",
	"expr : expr T_Iff expr",
	"expr : expr T_Insert binop expr",
	"expr : T_Insert binop expr",
	"expr : T_Not expr",
	"expr : T_Plus expr",
	"expr : T_Minus expr",
	"expr : T_Exists iter.list T_St expr",
	"expr : T_Forall iter.list T_St expr",
	"expr.list : expr",
	"expr.list : expr.list ',' expr",
	"pair.list : expr",
	"pair.list : expr T_St expr",
	"pair.list : pair.list ',' expr",
	"pair.list : pair.list ',' expr T_St expr",
	"counted : expr.list T_Dotdot expr",
	"from.stmt : T_Take expr T_Frome expr",
	"from.stmt : T_Take expr T_Fromb expr",
	"from.stmt : T_Take expr T_From expr",
	"former : /* empty */",
	"former : expr T_St iterator",
	"former : expr.list",
	"former : counted",
	"binop : T_Exp",
	"binop : T_Times",
	"binop : T_Slash",
	"binop : T_Mod",
	"binop : T_Div",
	"binop : T_Plus",
	"binop : T_Minus",
	"binop : T_With",
	"binop : T_Less",
	"binop : T_Eq",
	"binop : T_Ne",
	"binop : T_Lt",
	"binop : T_Gt",
	"binop : T_Le",
	"binop : T_Ge",
	"binop : T_In",
	"binop : T_Notin",
	"binop : T_Subset",
	"binop : T_And",
	"binop : T_Or",
	"binop : T_Impl",
	"binop : id",
	"binop : '.' id",
	"binop : '(' expr ')'",
	"binop : '.' '(' expr ')'",
	"end.func : T_End",
	"end.func : T_End T_Func",
	"func.const : func.head dcls stmts end.func",
	"func.const : T_St",
	"func.const : T_St args T_Arrow",
	"func.const : T_St args T_Arrow expr T_St",
	"args : id.list opt.part",
	"args : opt.part",
	"func.head : T_Func",
	"func.head : T_Func '(' args ')' ';'",
	"opt.part : /* empty */",
	"opt.part : T_Opt id.list",
	"dcls : /* empty */",
	"dcls : T_Local id.list ';' dcls",
	"dcls : T_Value id.list ';' dcls",
	"id.list : id",
	"id.list : id ',' id.list",
	"end.where : T_End",
	"where.clause : expr T_Where defns end.where",
	"defns : defn",
	"defns : defn ';'",
	"defns : defn ';' defns",
	"defn : bound T_Gets expr",
	"defn : id selector T_Gets expr",
	"bound : T_Missing",
	"bound : id",
	"bound : '[' bound.list ']'",
	"bound.list : bound",
	"bound.list : bound.list ',' bound",
};
#endif
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{ free(yys); free(yyv); return(0); }
#define YYABORT		{ free(yys); free(yyv); return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */

int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
{yyval = New_AST(T_Id, (AST_Ptr)str((char*)yypvt[-0]), ANULL);} break;
case 2:
{parsed = yypvt[-0]; return  0;} break;
case 3:
{parsed = yypvt[-1]; return  0;} break;
case 4:
{ if( !editting ) {
	      mcprintf("Syntax error, line %d.\n", line_num,0);
	      mcprintf("Error at or before end of:",0,0);
	      Show_Error();

	      if( yyin==stdin ) {
		  mcprintf("\nEnter '!clear'" ,0,0);
		  if( edit_flag ) mcprintf(" or '!edit'", 0,0);
		  mcprintf("\n",0,0);
	      } else {
		  mcputc('\n');
		  yyclear();
		  RT_ERROR("Cannot edit except at top level");
	      }
	  }
	} break;
case 5:
{ editting = false; } break;
case 6:
{ yyval = yypvt[-0]; } break;
case 9:
{yyval = New_AST(T_Prog, yypvt[-3], yypvt[-2]);} break;
case 11:
{yyval = Rev_Seq(yypvt[-1]);} break;
case 14:
{yyval = New_AST(0, yypvt[-0], yypvt[-2]);} break;
case 15:
{yyval = New_AST(0, yypvt[-0], ANULL);} break;
case 16:
{ yyval = New_AST(T_Source, Source_List,ANULL); Source_List = yyval; } break;
case 17:
{ yyval = yypvt[-1]; ast_2(yypvt[-1])= yypvt[-0];} break;
case 18:
{yyval = New_AST(T_Return,ANULL,ANULL);} break;
case 19:
{yyval = New_AST(T_Return,yypvt[-0],ANULL);} break;
case 20:
{yyval = New_AST(T_Read, yypvt[-0], ANULL);} break;
case 21:
{yyval = New_AST(T_Read, yypvt[-2], yypvt[-0]);} break;
case 22:
{yyval = New_AST(T_ReadF, yypvt[-0], ANULL);} break;
case 23:
{yyval = New_AST(T_ReadF, yypvt[-2], yypvt[-0]);} break;
case 24:
{yyval = New_AST(T_Print, yypvt[-0], ANULL);} break;
case 25:
{yyval = New_AST(T_Print, yypvt[-2], yypvt[-0]);} break;
case 26:
{yyval = New_AST(T_PrintF, yypvt[-0], ANULL);} break;
case 27:
{yyval = New_AST(T_PrintF, yypvt[-2], yypvt[-0]);} break;
case 28:
{yyval = New_AST(T_PrintF, yypvt[-0], ANULL);} break;
case 29:
{yyval = New_AST(T_PrintF, yypvt[-2], yypvt[-0]);} break;
case 30:
{yyval = New_AST(T_PrintF, 
			  New_AST(0,
				  New_AST(T_Om,ANULL,ANULL),
				  New_AST(0, New_AST(T_String,
						     (AST_Ptr)str("\n"),ANULL),
					  yypvt[-0])),
			  ANULL);} break;
case 31:
{yyval = New_AST(T_PrintF, 
			  New_AST(0,
				  New_AST(T_Om,ANULL,ANULL),
				  New_AST(0, New_AST(T_String,
						     (AST_Ptr)str("\n"),ANULL),
					  yypvt[-2])),
			  yypvt[-0]);} break;
case 32:
{yyval = New_AST(T_PrintF, 
			  New_AST(0,
				  New_AST(T_Om,ANULL,ANULL),
				  New_AST(0, New_AST(T_String,
						     (AST_Ptr)str("\n"),ANULL),
					  ANULL)),
			  ANULL);} break;
case 33:
{yyval = New_AST(T_PrintF, 
			  New_AST(0,
				  New_AST(T_Om,ANULL,ANULL),
				  New_AST(0, New_AST(T_String,
						     (AST_Ptr)str("\n"),ANULL),
					  ANULL)),
			  yypvt[-0]);} break;
case 35:
{yyval = New_AST(CALL, yypvt[-0], ANULL); } break;
case 38:
{yyval = yypvt[-0];} break;
case 39:
{yyval = ANULL; } break;
case 42:
{yyval = New_AST(T_If, New_AST(0, yypvt[-5], yypvt[-3]),
			    New_AST(0, Rev_Seq(yypvt[-2]), yypvt[-1]) ); } break;
case 43:
{yyval = New_AST(T_Elseif, New_AST(0, yypvt[-2], yypvt[-0]),
				yypvt[-4]); } break;
case 44:
{yyval = ANULL; } break;
case 49:
{yyval = New_AST(T_For, yypvt[-3], yypvt[-1]);} break;
case 50:
{yyval = New_AST(T_While, yypvt[-3], yypvt[-1]);} break;
case 51:
{yyval = New_AST(ITERS, yypvt[-0], ANULL);} break;
case 52:
{yyval = New_AST(ITERS, yypvt[-2], yypvt[-0]);} break;
case 53:
{yyval = Spread(yypvt[-2], yypvt[-0]);} break;
case 54:
{yyval = Spread(yypvt[-0], ANULL);} break;
case 55:
{yyval = New_AST(T_In, yypvt[-2], yypvt[-0]);} break;
case 56:
{yyval = New_AST(MAP, yypvt[-2], yypvt[-0]);} break;
case 57:
{yyval = New_AST('{', yypvt[-1], ANULL);} break;
case 58:
{yyval = New_AST('(', yypvt[-1], ANULL);} break;
case 59:
{yyval = New_AST(T_Dotdot, yypvt[-2], ANULL);} break;
case 60:
{yyval = New_AST(T_Dotdot, ANULL, yypvt[-1]);} break;
case 61:
{yyval = New_AST(T_Dotdot, yypvt[-3], yypvt[-1]);} break;
case 62:
{yyval = New_AST(CALL, ANULL, ANULL);} break;
case 63:
{yyval = New_AST(T_Gets, yypvt[-2], yypvt[-0]);} break;
case 66:
{yyval = New_AST(T_Missing, ANULL, ANULL);} break;
case 67:
{yyval = New_AST(T_Integer, (AST_Ptr)str((char*)yypvt[-0]),
					   ANULL);} break;
case 68:
{yyval = New_AST(T_Real,    (AST_Ptr)str((char*)yypvt[-0]),
					   ANULL);} break;
case 69:
{yyval = New_AST(T_String,  (AST_Ptr)str((char*)yypvt[-0]),
					   ANULL);} break;
case 70:
{yyval = New_AST(T_True,  ANULL, ANULL);} break;
case 71:
{yyval = New_AST(T_False, ANULL, ANULL);} break;
case 72:
{yyval = New_AST(T_Om,    ANULL, ANULL);} break;
case 73:
{yyval = New_AST(T_Newat, ANULL, ANULL);} break;
case 76:
{yyval = yypvt[-1];} break;
case 77:
{yyval = New_AST('[', yypvt[-1], ANULL); } break;
case 78:
{yyval = New_AST('{', yypvt[-1], ANULL); } break;
case 79:
{yyval = New_AST('#', yypvt[-0], ANULL); } break;
case 80:
{yyval = New_AST(SELECTOR, yypvt[-1], yypvt[-0]);} break;
case 81:
{yyval = New_AST(SELECTOR, yypvt[-1],
		    New_AST( '(', New_AST(0, yypvt[-0],
					 New_AST(0, yypvt[-3], ANULL)),
				  ANULL) );} break;
case 82:
{yyval = New_AST(SELECTOR, yypvt[-2],
		    New_AST( '(', New_AST(0, yypvt[-0],
					 New_AST(0, yypvt[-5], ANULL)),
				  ANULL) );} break;
case 83:
{yyval = New_AST('?',      yypvt[-2], yypvt[-0]);} break;
case 84:
{yyval = New_AST('@',      yypvt[-2], yypvt[-0]);} break;
case 85:
{yyval = New_AST(T_Exp,    yypvt[-2], yypvt[-0]);} break;
case 86:
{yyval = New_AST(T_Times,  yypvt[-2], yypvt[-0]);} break;
case 87:
{yyval = New_AST(T_Slash,  yypvt[-2], yypvt[-0]);} break;
case 88:
{yyval = New_AST(T_Mod,    yypvt[-2], yypvt[-0]);} break;
case 89:
{yyval = New_AST(T_Div,    yypvt[-2], yypvt[-0]);} break;
case 90:
{yyval = New_AST(T_Plus,   yypvt[-2], yypvt[-0]);} break;
case 91:
{yyval = New_AST(T_Minus,  yypvt[-2], yypvt[-0]);} break;
case 92:
{yyval = New_AST(T_With,   yypvt[-2], yypvt[-0]);} break;
case 93:
{yyval = New_AST(T_Less,   yypvt[-2], yypvt[-0]);} break;
case 94:
{yyval = New_AST(T_Eq,     yypvt[-2], yypvt[-0]);} break;
case 95:
{yyval = New_AST(T_Ne,     yypvt[-2], yypvt[-0]);} break;
case 96:
{yyval = New_AST(T_Lt,     yypvt[-2], yypvt[-0]);} break;
case 97:
{yyval = New_AST(T_Gt,     yypvt[-2], yypvt[-0]);} break;
case 98:
{yyval = New_AST(T_Le,     yypvt[-2], yypvt[-0]);} break;
case 99:
{yyval = New_AST(T_Ge,     yypvt[-2], yypvt[-0]);} break;
case 100:
{yyval = New_AST(T_In,     yypvt[-2], yypvt[-0]);} break;
case 101:
{yyval = New_AST(T_Notin,  yypvt[-2], yypvt[-0]);} break;
case 102:
{yyval = New_AST(T_Subset, yypvt[-2], yypvt[-0]);} break;
case 103:
{yyval = New_AST(T_And,    yypvt[-2], yypvt[-0]);} break;
case 104:
{yyval = New_AST(T_Or,     yypvt[-2], yypvt[-0]);} break;
case 105:
{yyval = New_AST(T_Impl,   yypvt[-2], yypvt[-0]);} break;
case 106:
{yyval = New_AST(T_Iff,    yypvt[-2], yypvt[-0]);} break;
case 107:
{yyval = New_AST(T_Insert, yypvt[-1], New_AST(0, yypvt[-3], yypvt[-0]) );} break;
case 108:
{yyval = New_AST(T_Insert, yypvt[-1], 
		      New_AST(0, ANULL, yypvt[-0]) );} break;
case 109:
{yyval = New_AST(T_Not, ANULL, yypvt[-0]);} break;
case 110:
{yyval = New_AST(T_Plus, ANULL, yypvt[-0]);} break;
case 111:
{yyval = New_AST(T_Minus, ANULL, yypvt[-0]);} break;
case 112:
{yyval = New_AST(T_Exists, yypvt[-2], yypvt[-0]);} break;
case 113:
{yyval = New_AST(T_Forall, yypvt[-2], yypvt[-0]);} break;
case 114:
{yyval = New_AST(0, yypvt[-0], ANULL); } break;
case 115:
{yyval = New_AST(0, yypvt[-0], yypvt[-2]); } break;
case 116:
{yyval = New_AST(0, New_AST(T_Om,ANULL,ANULL),
					 New_AST(0,yypvt[-0], ANULL)); } break;
case 117:
{yyval = New_AST(0,yypvt[-0],New_AST(0,yypvt[-2],ANULL)); } break;
case 118:
{yyval = New_AST(0, New_AST(T_Om,ANULL,ANULL),
			 New_AST(0, yypvt[-0], yypvt[-2])); } break;
case 119:
{yyval = New_AST(0,yypvt[-0],New_AST(0,yypvt[-2],yypvt[-4])); } break;
case 120:
{yyval = New_AST(T_Dotdot, yypvt[-2], yypvt[-0]);} break;
case 121:
{yyval= New_AST(T_Frome, yypvt[-2], yypvt[-0]);} break;
case 122:
{yyval= New_AST(T_Fromb, yypvt[-2], yypvt[-0]);} break;
case 123:
{yyval= New_AST(T_From,  yypvt[-2], yypvt[-0]);} break;
case 124:
{yyval = ANULL;} break;
case 125:
{yyval = New_AST(T_St, yypvt[-2], yypvt[-0]);} break;
case 128:
{yyval = New_AST(T_Exp,	ANULL, ANULL);} break;
case 129:
{yyval = New_AST(T_Times,	ANULL, ANULL);} break;
case 130:
{yyval = New_AST(T_Slash,	ANULL, ANULL);} break;
case 131:
{yyval = New_AST(T_Mod,	ANULL, ANULL);} break;
case 132:
{yyval = New_AST(T_Div,	ANULL, ANULL);} break;
case 133:
{yyval = New_AST(T_Plus,	ANULL, ANULL);} break;
case 134:
{yyval = New_AST(T_Minus,	ANULL, ANULL);} break;
case 135:
{yyval = New_AST(T_With,	ANULL, ANULL);} break;
case 136:
{yyval = New_AST(T_Less,	ANULL, ANULL);} break;
case 137:
{yyval = New_AST(T_Eq,	ANULL, ANULL);} break;
case 138:
{yyval = New_AST(T_Ne,	ANULL, ANULL);} break;
case 139:
{yyval = New_AST(T_Lt,	ANULL, ANULL);} break;
case 140:
{yyval = New_AST(T_Gt,	ANULL, ANULL);} break;
case 141:
{yyval = New_AST(T_Le,	ANULL, ANULL);} break;
case 142:
{yyval = New_AST(T_Ge,	ANULL, ANULL);} break;
case 143:
{yyval = New_AST(T_In,	ANULL, ANULL);} break;
case 144:
{yyval = New_AST(T_Notin,	ANULL, ANULL);} break;
case 145:
{yyval = New_AST(T_Subset, ANULL, ANULL);} break;
case 146:
{yyval = New_AST(T_And,	ANULL, ANULL);} break;
case 147:
{yyval = New_AST(T_Or,	ANULL, ANULL);} break;
case 148:
{yyval = New_AST(T_Impl,	ANULL, ANULL);} break;
case 150:
{yyval = yypvt[-0];} break;
case 151:
{yyval = New_AST('(',	yypvt[-1],    ANULL);} break;
case 152:
{yyval = New_AST('(',	yypvt[-1],    ANULL);} break;
case 155:
{ func_level --;
	      if( func_level==0 ) Source_Flush();

	      yyval = New_AST(T_Func, 
			   New_AST(T_Source,
				   (func_level==0 ? Func_List : Nil),
				   ast_2(yypvt[-3])), /* ARGS */
			   New_AST(0, yypvt[-2],      /* dcls */
				   New_AST(0,ast_1(yypvt[-3]), /* First line */
					   yypvt[-1])) );
	      if(func_level==0) {
		  Func_List = Nil;
	      }
	    } break;
case 156:
{ yyval = New_AST(T_Source, Source_List,ANULL); Source_List = yyval;
          if( func_level == 0 ) {
	      Func_Tail = Func_List = mcCons(Nil,Nil);
          }
	  func_level++;
        } break;
case 157:
{ yyval = New_AST(0,yypvt[-2],yypvt[-1]); } break;
case 158:
{ func_level --;
	      if( func_level==0 ) Source_Flush();

	      yyval = New_AST(T_Func, 
		     New_AST(T_Source,
			     (func_level==0 ? Func_List : Nil),
			     ast_2(yypvt[-2])), /* ARGS */
		     New_AST(0, ANULL, /* DCLS */
			     New_AST(0, 
				     yypvt[-5], /* First line */
				     New_AST(0, New_AST(T_Return, yypvt[-1], ANULL),
					     ANULL))));
	      if(func_level==0) {
		  Func_List = Nil;
	      }
	    } break;
case 159:
{ yyval = New_AST(0,yypvt[-1],yypvt[-0]); } break;
case 160:
{ yyval = New_AST(0,ANULL,yypvt[-0]); } break;
case 161:
{ yyval = New_AST(T_Source, Source_List,ANULL); Source_List = yyval;
          if( func_level == 0 ) {
	      Func_Tail = Func_List = mcCons(Nil,Nil);
          }
	  func_level++;
        } break;
case 162:
{ yyval = New_AST(0,yypvt[-4],yypvt[-2]); } break;
case 163:
{ yyval = ANULL; } break;
case 164:
{ yyval = yypvt[-0]; } break;
case 165:
{ yyval = ANULL; } break;
case 166:
{ yyval = New_AST(T_Local, yypvt[-2], yypvt[-0]); } break;
case 167:
{ yyval = New_AST(T_Value, yypvt[-2], yypvt[-0]); } break;
case 168:
{ yyval = New_AST(0, yypvt[-0], ANULL); } break;
case 169:
{ yyval = New_AST(0, yypvt[-2], yypvt[-0]  ); } break;
case 171:
{ yyval = New_AST(T_Where, yypvt[-3], yypvt[-1]); } break;
case 172:
{ yyval = New_AST(0, yypvt[-0], ANULL); } break;
case 173:
{ yyval = New_AST(0, yypvt[-1], ANULL); } break;
case 174:
{ yyval = New_AST(0, yypvt[-2], yypvt[-0]); } break;
case 175:
{ yyval = New_AST( T_Gets, yypvt[-2],yypvt[-0]); } break;
case 176:
{ yyval = New_AST(SELECTOR, New_AST(SELECTOR, yypvt[-3], yypvt[-2]), yypvt[-0]); } break;
case 177:
{yyval = New_AST(T_Missing, ANULL, ANULL);} break;
case 179:
{yyval = New_AST('[', yypvt[-1], ANULL); } break;
case 180:
{ yyval = New_AST(0, yypvt[-0], ANULL); } break;
case 181:
{ yyval = New_AST(0, yypvt[-0], yypvt[-2]); } break;
	}
	goto yystack;		/* reset registers in driver code */
}
